/*
 * This is an example client that attaches to an account factory
 * and uses it to create accounts and manipulate the
 */

#include <stdio.h>

#include "CosNaming.h" /* To use the Naming Service */
#include "name.h"  /* to get create_name helper function */
#include "Mystring.h"

int main (int argc, char *argv[]) {

  MyServer fac;		      /* The server-side factory object */
	char *test = "pras";
  CORBA_ORB orb=NULL;         /* This is our ORB */

  CORBA_Environment ev;       /* CORBA exception information */

  CosNaming_NamingContext name_srv; /* The name server */
  CosNaming_Name* fac_name;    /* This holds the name of our server */

  CORBA_exception_init(&ev);

  printf("\npras : %s\n", argv[1]);
  /* Initialize the orb. The initialization routine checks the command
   * line parameters for directives that affect the orb */
  orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);

  /* Here we get the name server from the ORB and publish the server */
  name_srv = CORBA_ORB_string_to_object (orb, argv[1], &ev);
 //   CORBA_ORB_resolve_initial_references(orb, "NameService", &ev);
		g_assert(ev._major != CORBA_SYSTEM_EXCEPTION);

  if(name_srv == NULL)
	   printf("ERROR in NameServ \n");
  else
		printf("name_srv : %d\n", name_srv);

  printf ("After resolve\n");
  fac_name = create_name("pras.example");

	printf ("After create\n");
  fac = CosNaming_NamingContext_resolve(name_srv, fac_name, &ev);
	g_assert(ev._major != CORBA_SYSTEM_EXCEPTION);

  if(fac == NULL)
	   printf("ERROR in Factory \n");
  else
		printf("fac : %d\n", fac);
  
  printf ("before function call\n");
  /* Use the factory to create a couple of accounts */
  test = "prashant";	
  test = MyServer_getNewString(fac, test, &ev);
  
  printf ("After function call\n");
  printf ("string is\n");
  printf (test);
  printf ("\n");
 

  /* We're done running, clean up */
  CORBA_Object_release(fac, &ev);

  CORBA_ORB_shutdown(orb, CORBA_FALSE, &ev);


}


