#include "Mystring.h"

/*** App-specific servant structures ***/

typedef struct
{
   POA_MyServer servant;
   PortableServer_POA poa;

}
impl_POA_MyServer;

/*** Implementation stub prototypes ***/

static void impl_MyServer__destroy(impl_POA_MyServer * servant,
				   CORBA_Environment * ev);
static CORBA_string
impl_MyServer_getNewString(impl_POA_MyServer * servant,
			   const CORBA_char * s, CORBA_Environment * ev);

/*** epv structures ***/

static PortableServer_ServantBase__epv impl_MyServer_base_epv = {
   NULL,			/* _private data */
   NULL,			/* finalize routine */
   NULL,			/* default_POA routine */
};
static POA_MyServer__epv impl_MyServer_epv = {
   NULL,			/* _private */
   (gpointer) & impl_MyServer_getNewString,

};

/*** vepv structures ***/

static POA_MyServer__vepv impl_MyServer_vepv = {
   &impl_MyServer_base_epv,
   &impl_MyServer_epv,
};

/*** Stub implementations ***/

static MyServer
impl_MyServer__create(PortableServer_POA poa, CORBA_Environment * ev)
{
   MyServer retval;
   impl_POA_MyServer *newservant;
   PortableServer_ObjectId *objid;

   newservant = g_new0(impl_POA_MyServer, 1);
   newservant->servant.vepv = &impl_MyServer_vepv;
   newservant->poa = poa;
   POA_MyServer__init((PortableServer_Servant) newservant, ev);
   objid = PortableServer_POA_activate_object(poa, newservant, ev);
   CORBA_free(objid);
   retval = PortableServer_POA_servant_to_reference(poa, newservant, ev);

   return retval;
}

static void
impl_MyServer__destroy(impl_POA_MyServer * servant, CORBA_Environment * ev)
{
   PortableServer_ObjectId *objid;

   objid = PortableServer_POA_servant_to_id(servant->poa, servant, ev);
   PortableServer_POA_deactivate_object(servant->poa, objid, ev);
   CORBA_free(objid);

   POA_MyServer__fini((PortableServer_Servant) servant, ev);
   g_free(servant);
}

static CORBA_string
impl_MyServer_getNewString(impl_POA_MyServer * servant,
			   const CORBA_char * s, CORBA_Environment * ev)
{
   CORBA_string retval;
   printf("In Impl\n");
   retval = CORBA_string_dup("Hello how r u");
   return retval;
}
